UNIT mTAnwendung;

interface

uses   mSuM, mUhr,
       mTKnopf, mTKreisknopf, mTRechteckKnopf,
       mTMuehle, mTRechtsMuehle, mTHollMuehle, mTKreismuehle;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        Muehle1 : TMuehle;
        Muehle2 : TMuehle;
        Muehle3 : TRechtsMuehle;
        Muehle4 : THollmuehle;
        Muehle5 : TKreismuehle;
        KEnde : TRechteckknopf;
        dieUhr : Uhr;

     //Objektbeziehungen:
        // hatTKnopf : TKnopf;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(20,20,10,'+',dieMaus);
  KLangsamer    := TKreisknopf.init(20,50,10,'---',dieMaus);
  KEnde         := TRechteckknopf.init(300,400,80,'ENDE',dieMaus);
  Muehle1       := TMuehle.init(60,300,100,3,rot);
  Muehle2       := TMuehle.init(400,200,60,2,blau);
  Muehle3       := TRechtsMuehle.init(500,400,80,4,magenta);
  Muehle4       := THollMuehle.init(600,250,70,1,schwarz);
  Muehle5       := TKreisMuehle.init(200,350,100,5,braun);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat
         if KSchneller.angeklickt then begin
            Muehle1.schneller;
            Muehle2.schneller;
            Muehle3.schneller;
            Muehle4.schneller;
            Muehle5.schneller;
         end
         else if KLangsamer.angeklickt then begin
            Muehle1.langsamer;
            Muehle2.langsamer;
            Muehle3.langsamer;
            Muehle4.langsamer;
            Muehle5.langsamer;
         end;
         muehle1.drehe;
         muehle2.drehe;
         muehle3.drehe;
         muehle4.drehe;
         muehle5.drehe;
         dieUhr.warte(10)
   until KEnde.angeklickt
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  Muehle1.gibFrei;
  Muehle2.gibFrei;
  Muehle3.gibFrei;
  Muehle4.gibFrei;
  Muehle5.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
