UNIT mTMuehle;

interface

uses        mSuM;
// Uses-Klausel ggf. anpassen

type
   TMuehle = CLASS

     // Attribute
     protected
         hatStift : BuntStift;
         zFarbe : GanzeZahl;
         kenntMaus : Maus;
         zGeschwindigkeit : Zahl;
         zGroesse : Zahl;
         zRichtung : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;

     // Methoden
     protected
        procedure zeichne; virtual;
     public
        constructor init(pX,pY,pGroesse,pGeschwindigkeit:Zahl;pFarbe:ganzeZahl);
        procedure drehe; virtual;
        procedure langsamer;
        procedure schneller;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehle: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (protected) -----------------------------------------
procedure TMuehle.zeichne;
begin
  hatStift.setzeFarbe(zFarbe);
  hatStift.hoch;
  hatStift.bewegeBis(zXpos,zYPos);
  hatStift.setzeLinienBreite(3);
  hatStift.runter;
  hatStift.bewegeBis(zXpos,zYpos-zGroesse);
  hatStift.dreheBis(zRichtung);
  hatStift.setzeLinienBreite(2);
  hatStift.bewegeUm(zGroesse/2);
  hatStift.dreheUm(180);
  hatStift.hoch;
  hatStift.bewegeUm(zGroesse/2);
  hatStift.runter;
  hatStift.bewegeUm(zGroesse/2);
  hatStift.hoch
end;

//-------- init (public) -----------------------------------------------
constructor TMuehle.init(pX,pY,pGroesse,pGeschwindigkeit:Zahl;pFarbe:ganzeZahl);
begin
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zGeschwindigkeit := pGeschwindigkeit;
  zRichtung := 0;
  zFarbe := pFarbe;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- drehe (public) ----------------------------------------------
procedure TMuehle.drehe;
begin
   zeichne;
   zRichtung := zRichtung + zGeschwindigkeit;
   zeichne
end;

//-------- langsamer (public) ------------------------------------------
procedure TMuehle.langsamer;
begin
  if zGeschwindigkeit > 0.1 then zGeschwindigkeit := zGeschwindigkeit - 0.01
end;

//-------- schneller (public) ------------------------------------------
procedure TMuehle.schneller;
begin
  zGeschwindigkeit := zGeschwindigkeit + 0.01
end;

//-------- gibFrei (public) --------------------------------------------
destructor TMuehle.gibFrei;
begin
  zeichne
end;

end.
