UNIT mTRechteckKnopf;

interface

uses   mSuM, mTKnopf;
// Uses-Klausel ggf. anpassen

type
   TRechteckKnopf = CLASS(TKnopf)

     // Attribute

     // Methoden
     public
        procedure zeichne; override;
        function angeklickt : Wahrheitswert; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteckKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (public) --------------------------------------------
procedure TRechteckKnopf.zeichne;
begin
  hatStift.bewegeBis(zXPos,zYPos);
  hatStift.setzeFarbe(blau);
  hatStift.setzeLinienBreite(2);
  hatStift.zeichneRechteck(zGroesse,17);
  hatStift.bewegeBis(zXPos+(zGroesse-hatStift.Textbreite(zAufschrift))/2,zYPos+1);
  hatStift.setzeFarbe(schwarz);
  hatStift.setzeLinienBreite(2);
  hatStift.schreibeText(zAufschrift);
end;

//-------- angeklickt (public) -----------------------------------------
function TRechteckKnopf.angeklickt : Wahrheitswert;
begin
  result := (kenntMaus.istgedrueckt) and
            (kenntMaus.hPosition > zXpos ) and
            (kenntMaus.hPosition < zXPos + zGroesse) and
            (kenntMaus.vPosition > zYPos) and
            (kenntMaus.vPosition < zYPos+12)

end;

end.
