UNIT mTCorpusKapp;

interface

uses mSum, mTCorpus;
// Uses-Klausel ggf. anpassen

type
   TCorpusKapp = CLASS(TCorpus)

     // Attribute
     private
        zFarbe : Integer;

     // Methoden
     public
        constructor init(px,py,pFarbe,pGroesse:Integer); override;
        procedure zeichne; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TCorpusKapp: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TCorpusKapp.init(px,py,pFarbe,pGroesse:Integer);
begin
  inherited init (px,py,pFarbe,pGroesse);
  zFarbe := pFarbe;
  hatBuntstift.setzeLinienbreite (pGroesse div 5);
end;

//-------- zeichne (public) --------------------------------------------
procedure TCorpusKapp.zeichne;
begin
  With hatBuntstift do
  begin
  hoch;
  setzeFuellMuster(gefuellt);
  setzeFarbe(schwarz);
  bewegeBis(zx,zy);
  runter;
  zeichneKreis(zGroesse*2);
  hoch;
  bewegeBis(zx-2*zGroesse,zy+zGroesse div 5);
  runter;
  radiere;
  zeichneRechteck(4*zGroesse,4*zGroesse);
  normal;
  setzeFarbe(zFarbe);
  bewegeBis(zx+2*zGroesse,zy+zGroesse div 5);
  bewegeBis(zx+3*zGroesse,zy+9*zGroesse);
  bewegeBis(zx-3*zGroesse,zy+9*zGroesse);
  bewegeBis(zx-2*zGroesse,zy+zGroesse div 5);
  hoch;
  setzeFarbe(schwarz);
  bewegeBis(zx-3*zGroesse,zy+9*zGroesse+zGroesse div 5);
  runter;
  zeichneRechteck(6*zGRoesse,2*zGroesse);
  if (zFarbe = rot) AND (zGroesse >= 10)
  then begin
       hoch;
       setzeFarbe(zFarbe);
       setzeSchriftgroesse (zGroesse);
       setzeSchriftArt ('Times New Roman');
       bewegebis (zx-textBreite('Moulin Rouge')div 2, zy+10*zGroesse);
       schreibeText ('Moulin Rouge');
       end;
  end;
end;

end.
