UNIT mTKnopf;

interface

uses   mSum;
// Uses-Klausel ggf. anpassen

type
   TKnopf = CLASS

     // Attribute
     protected
         hatStift : Buntstift;
         kenntMaus : Maus;
         zAnkerx : zahl;
         zAnkery : zahl;
         zText : zeichenkette;

     //Objektbeziehungen:
        // hatBuntstift : Buntstift;
        // kenntMaus : Maus;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
        function istGetroffen : boolean; virtual; abstract;
     public
        constructor init(pAnkerx,pAnkery: integer; pText : string);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pAnkerx,pAnkery: integer; pText : string);
begin
  zAnkerx := pAnkerx; zAnkery := pAnkery; zText := pText;
  hatStift := Buntstift.init;
  kenntMaus := Maus.init;
  hatStift.bewegeBis(pAnkerx,pAnkery);
  hatStift.setzeLinienBreite(2);
  hatStift.setzeSchriftStil(fett);
  hatStift.setzeSchriftGroesse(15);
  zeichne;
  //Hier Code einfgen.
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  //Hier Code einfgen.
end;
 
end.
