UNIT mTAnwendung;

interface

uses      mSuM, mUhr, mtknopf,mtRechteckknopf, mtKreisknopf,mTMuehle;
// Uses-Klausel ggf. anpassen
const Anzahl = 15  ;
type
   TAnwendung = CLASS

     // Attribute
     private
        zWindstaerke : ganzeZahl;
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        Muehle : Array[1..Anzahl] of TMuehle;
        KEnde : TRechteckknopf;
        dieUhr : Uhr;


     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;var l : Integer;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(50,20,20,rot,'+');
  KLangsamer    := TKreisknopf.init(50,80,20,blau,'-');
  KEnde         := TRechteckknopf.init(50,650,30, schwarz,'Endknopf');
  For l:= 1 to Anzahl Do
   Muehle[l] := TMuehle.init (Random(900)+100,Random(450)+100,60,Random(10)+2,Random(16),Random(4));
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
var  n : Integer;
begin
   repeat
     For n := 1 to Anzahl do
     begin
         if KSchneller.angeklickt then begin
            Muehle[n].schneller
         end
         else if KLangsamer.angeklickt then begin
            Muehle[n].langsamer
         end;
         Muehle[n].drehe(zWindstaerke);
         dieUhr.warte(1);
     end;
     until KEnde.angeklickt
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
