UNIT mTKnopf;

interface

uses mSuM;

type
   TKnopf = CLASS

     // Attribute
     protected
         hatStift : Buntstift;
         kenntMaus : Maus;
         zgroesse : Zahl;
         zxposition : Zahl;
         zyposition : Zahl;
         ztext : zeichenkette;

     //Objektbeziehungen:
        // hatBuntstift : Buntstift;
        // kenntMaus : Maus;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
        function getroffen : boolean; virtual; abstract;
     public
        constructor init(px, py, pgroesse : Zahl; pmaus : maus; ptext : zeichenkette);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(px, py, pgroesse : Zahl; pmaus : maus; ptext : zeichenkette);
begin
  zxPosition := px;
  zyPosition := py;
  zGroesse := pGroesse;
  hatStift := Buntstift.init;
  hatStift.bewegeBis (zxPosition, zyPosition);
  ztext := ptext;
  self.zeichne;
  kenntMaus := pMaus;


end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  hatStift.gibfrei
end;

end.
