UNIT mTmuehle;

interface

uses    mSum;
// Uses-Klausel ggf. anpassen

type
   Tmuehle = CLASS

     // Attribute
     protected
         hatStift : Buntstift;
         zFarbe : INTEGER;
         zGeschwindigkeit : Zahl;
         zgroesse : Zahl;
         zx : Zahl;
         zy : Zahl;

     //Objektbeziehungen:
        // hatBuntstift : Buntstift;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
        procedure zeichneRotor; virtual; abstract;
     public
        constructor init(px,py,pgroesse,pGeschwindigkeit:Zahl;pFarbe:INTEGER);
        procedure bewegeRotor;
        procedure bewegeRotorLangsamer;
        procedure bewegeRotorSchneller;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         Tmuehle: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor Tmuehle.init(px,py,pgroesse,pGeschwindigkeit:Zahl;pFarbe:INTEGER);
begin
  hatStift := BuntStift.init;
  zFarbe := pFarbe;
  zGeschwindigkeit := pGeschwindigkeit;
  zgroesse := pGroesse;
  zx := px;
  zy := py;
  self.zeichne;
  hatStift.wechsle;
  self.zeichneRotor;
end;

//-------- bewegeRotor (public) ----------------------------------------
procedure Tmuehle.bewegeRotor;
begin
  self.zeichneRotor;  //lscht den alten Rotor
  hatStift.dreheUm(zGeschwindigkeit);
  self.zeichneRotor;  //zeichnet den neuen Rotor
end;

//-------- bewegeRotorLangsamer (public) -------------------------------
procedure Tmuehle.bewegeRotorLangsamer;
begin
  zGeschwindigkeit := zGeschwindigkeit * 0.9;
end;

//-------- bewegeRotorSchneller (public) -------------------------------
procedure Tmuehle.bewegeRotorSchneller;
begin
  zGeschwindigkeit := zGeschwindigkeit * 1.1;
end;

//-------- gibFrei (public) --------------------------------------------
destructor Tmuehle.gibFrei;
begin
  hatStift.gibFrei;
end;

end.
