UNIT mTKreisknopf;

interface

uses  mtKnopf, mSuM;
// Uses-Klausel ggf. anpassen

type
   TKreisknopf = CLASS(TKnopf)

     // Attribute
     private
        zRadius : zahl;

     // Methoden
     private
        procedure zeichne; override;
     public
        function angeklickt : Boolean; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKreisknopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TKreisknopf.zeichne;
begin
  zRadius := 20;
  hatStift.bewegeBis (zAnkerX, zAnkerY);
  hatStift.zeichneKreis (zRadius);
  hatStift.bewegeBis (zAnkerX - zRadius / 2, zAnkerY - zRadius / 2);
  hatStift.setzeSchriftGroesse (20);
  hatStift.schreibeText (zTitel)
end;

//-------- angeklickt (public) -----------------------------------------
function TKreisknopf.angeklickt : Boolean;
begin
  result := kenntMaus.istGedrueckt and
    (sqr (zAnkerX - kenntMaus.hPosition) + sqr (zAnkerY - kenntMaus.vPosition) < sqr (zRadius));
end;

end.
