UNIT mTMuehle;

interface

uses        mSuM, mUhr;

const laenge = 60.0;
      breite = 30.0;
// Uses-Klausel ggf. anpassen

type
   TMuehle = CLASS

     // Attribute
     private
        zGeschwindigkeit : Zahl;
     protected
         first : boolean;
         hatStift : BuntStift;
         zBreite : zahl;
         zHoehe : zahl;
         zX : zahl;
         zY : zahl;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
     public
        constructor init(px,py,pGeschwindigkeit,pHoehe:zahl;pFarbe:ganzeZahl);
        procedure bewege;
        procedure langsamer;
        procedure schneller;
        destructor GibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehle: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TMuehle.init(px,py,pGeschwindigkeit,pHoehe:zahl;pFarbe:ganzeZahl);
    begin
       hatStift := BuntStift.init;
       hatStift.setzeFarbe (pFarbe);
       hatStift.setzeLinienBreite (2);
       hatStift.wechsle;
       hatStift.dreheUm (random (360));
       zX := px;
       zY := py;
       zGeschwindigkeit := pGeschwindigkeit;
       zHoehe := pHoehe;
       zBreite := zHoehe / 10;
       first := true;
       zeichne
    end;

//-------- bewege (public) ---------------------------------------------
procedure TMuehle.bewege;
  begin
    zeichne;
    hatStift.dreheUm (zGeschwindigkeit);
    zeichne;
  end;

//-------- langsamer (public) ------------------------------------------
procedure TMuehle.langsamer;
begin
  zGeschwindigkeit := zGeschwindigkeit - 0.1
end;

//-------- schneller (public) ------------------------------------------
procedure TMuehle.schneller;
begin
  zGeschwindigkeit := zGeschwindigkeit + 0.1
end;

//-------- GibFrei (public) --------------------------------------------
destructor TMuehle.GibFrei;
    begin
      hatStift.gibfrei;
    end;

end.
