UNIT mTAuto;

interface

uses   mSuM,mUhr;

    const laenge = 60.0;
          breite = 30.0;
// Uses-Klausel ggf. anpassen

type
   TAuto = CLASS

     // Attribute
     private
        hatStift : Stift;
        zGeschwindigkeit : Zahl;
        zX : zahl;
        zY : zahl;

     // Methoden
     private
        procedure zeichne;
     public
        constructor init(px,py:zahl);
        procedure bewege;
        procedure langsamer;
        procedure schneller;
        procedure setzeAuf(pXpos,pYPos:zahl);
        function hPosition : zahl;
        destructor GibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAuto: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TAuto.zeichne;
  begin
    with hatStift do
      begin
        hoch;
        bewegeBis(zX,zY);
        wechsle;
        dreheBis(0);
        bewegeUm(laenge*0.1);
        dreheBis (90);
        bewegeUm(breite *0.5);
        runter;
        bewegeUm(-breite);
        hoch;
        bewegeUm(breite*0.5);
        //runter;
        dreheBis(180);
        BewegeUm(laenge*0.5);
        BewegeUm(laenge*0.1);
        dreheUm(-90);
        BewegeUm(breite*0.5);
        dreheUm(-90);

        runter;
        dreheBis(0);
        BewegeUm(laenge*0.8);
        DreheUm(-90);
        BewegeUm(breite*0.2);
        DreheUm(90);
        bewegeUm(laenge*0.2);
        DreheUm(-90);
        bewegeUm(breite*0.6);
        dreheUm(-90);
        bewegeUm(laenge*0.2);
        dreheUm(90);
        bewegeUm(breite*0.2);
        dreheUm(-90);
        bewegeUm(laenge*0.8);
        dreheUm(-90);
        bewegeUm(breite);
        hoch;
        bewegeUm(-breite*0.5);
        dreheBis(0);
        bewegeUm(laenge*0.5);
        normal
      end;
  end;

//-------- init (public) -----------------------------------------------
constructor TAuto.init(px,py:zahl);
    begin
       hatStift := Stift.init;
       zX := px;
       zY := py;
       zGeschwindigkeit := 3;
       zeichne
    end;

//-------- bewege (public) ---------------------------------------------
procedure TAuto.bewege;
  begin
    zeichne;
    zX := zX + zGeschwindigkeit;
    zeichne;
  end;

//-------- langsamer (public) ------------------------------------------
procedure TAuto.langsamer;
begin
  zGeschwindigkeit := zGeschwindigkeit - 0.1
end;

//-------- schneller (public) ------------------------------------------
procedure TAuto.schneller;
begin
  zGeschwindigkeit := zGeschwindigkeit + 0.1
end;

//-------- setzeAuf (public) -------------------------------------------
procedure TAuto.setzeAuf(pXpos,pYPos:zahl);
   begin
      zeichne;
      zX := pXpos ;
      zY := pYpos ;
      zeichne
   end;

//-------- hPosition (public) ------------------------------------------
function TAuto.hPosition : zahl;
   begin
    result := zX;
   end;

//-------- GibFrei (public) --------------------------------------------
destructor TAuto.GibFrei;
    begin
      hatStift.gibfrei;
    end;

end.
