UNIT mTKreisKnopf;

interface

uses mSuM,mTKnopf;
// Uses-Klausel ggf. anpassen

type
   TKreisKnopf = CLASS(TKnopf)

     // Attribute
     // Methoden
     public
        procedure zeichne; override;
        function angeklickt : Wahrheitswert; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKreisKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (public) --------------------------------------------
procedure TKreisKnopf.zeichne;
begin
  hatStift.bewegeBis(zXPos,zYPos);
  hatStift.setzeFarbe(rot);
  hatStift.zeichneKreis(zGroesse);
  hatStift.bewegeBis(zXPos-hatStift.TextBreite(zAufschrift)/2,zYPos-6);
  hatStift.setzeFarbe(schwarz);

  hatStift.schreibeText(zAufschrift);
end;

//-------- angeklickt (public) -----------------------------------------
function TKreisKnopf.angeklickt : Wahrheitswert;
var erg : Wahrheitswert;
begin
  erg := false;
  if kenntmaus.istgedrueckt then begin
     if not bereitsangeklickt and
            (sqrt(sqr(kenntMaus.hPosition-zXpos) +
             sqr(kenntMaus.vPosition-zYpos))
             <=zGroesse ) then begin
        bereitsangeklickt := true ;
        erg := true
     end
  end
  else begin
     bereitsangeklickt := false;
     erg := false
  end;
  result := erg
end;

end.
