UNIT mTKreisKnopf;

interface

uses  mSuM,mTKnopf;
// Uses-Klausel ggf. anpassen

type
   TKreisKnopf = CLASS(TKnopf)

     // Attribute

     // Methoden
     public
        procedure zeichne; override;
        function angeklickt : Wahrheitswert; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKreisKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (public) --------------------------------------------
procedure TKreisKnopf.zeichne;
begin
  hatStift.bewegeBis(zXPos,zYPos);
  hatStift.setzeFarbe(rot);
  hatStift.setzeLinienBreite(2);
  hatStift.zeichneKreis(zGroesse);
  hatStift.bewegeBis(zXPos-hatStift.TextBreite(zAufschrift)/2,zYPos-6);
  hatStift.setzeFarbe(schwarz);
  hatStift.setzeLinienBreite(1);
  hatStift.schreibeText(zAufschrift);
end;

//-------- angeklickt (public) -----------------------------------------
function TKreisKnopf.angeklickt : Wahrheitswert;
begin
  result := (kenntMaus.istgedrueckt) and
            (sqrt(sqr(kenntMaus.hPosition-zXpos) + sqr(kenntMaus.vPosition-zYpos))
     <=zGroesse )
end;

end.
