UNIT mTAnwendung;

interface

uses    mSuM, mUhr, mTknopf, mTrechteckknopf, mTKreisknopf,
        mTMuehle;

type
   TAnwendung = CLASS

     private
        derBildschirm : Bildschirm;
        dieMaus       : Maus;
        KLangsamer    : TKreisknopf;
        KSchneller    : TKreisknopf;
        KRuhe         : TKreisknopf;
        KEnde         : TRechteckknopf;
        dieUhr        : Uhr;
        Muehle1       : TMuehle;
        Muehle2       : TMuehle;
        Muehle3       : TMuehle;
        Muehle4       : TMuehle;
        Muehle5       : TMuehle;


     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(50,480,'<--',dieMaus);
  KLangsamer    := TKreisknopf.init(150,480,'-->',dieMaus);
  KRuhe         := TKreisknopf.init(100,480,'|||',dieMaus);
  KEnde         := TRechteckknopf.init(75,520,'Ende',dieMaus);

  // x, y Drehpunkt / Farbe / Flgellnge (wird mit 10 multipliziert)
  // Mhlencorpus / Anzahl Flgel / Startwinkelinkrement (neg. mglich)

  //Mhlencorpus zur Zeit nicht eingebaut


  muehle1       := TMuehle.init(100,80,rot,4,0,3,2.0);
  muehle2       := TMuehle.init(550,400,blau,10,1,6,0.5);
  muehle3       := TMuehle.init(450,100,gruen,7,2,8,0.5);
  muehle4       := TMuehle.init(200,250,schwarz,6,0,1,-1.0);
  muehle5       := TMuehle.init(800,210,rot,20,2,2,-0.25);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat
         if KSchneller.angeklickt then begin
             muehle1.schneller;
             muehle2.schneller;
             muehle3.schneller;
             muehle4.schneller;
             muehle5.schneller;
         end ;

         if KLangsamer.angeklickt then begin
            muehle1.langsamer;
            muehle2.langsamer;
            muehle3.langsamer;
            muehle4.langsamer;
            muehle5.langsamer;
         end;

         If  kRuhe.angeklickt then
                               begin
                                muehle1.ruhe; muehle2.ruhe;
                                muehle3.ruhe; muehle4.ruhe;
                                muehle5.ruhe;
                                repeat
                                until klangsamer.angeklickt
                                     or kschneller.angeklickt
                                     or kende.angeklickt;
                               end;
          muehle1.drehe;
          muehle2.drehe;
          muehle3.drehe;
          muehle4.drehe;
          muehle5.drehe;

          dieUhr.warte(2);

   until KEnde.angeklickt
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  muehle5.gibFrei;
  muehle4.gibFrei;
  muehle3.gibFrei;
  muehle2.gibFrei;
  muehle1.gibFrei;
  KEnde.gibFrei;
  KRuhe.gibFrei;
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  dieUhr.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei ;
end;

end.
