UNIT mTCorpus;

interface

uses mSum;
// Uses-Klausel ggf. anpassen

type
   TCorpus = CLASS

     // Attribute

     protected
        hatBuntstift : Buntstift;
        zGroesse : Integer;
        zx : Integer;
        zy : Integer;

     // Methoden
     public
        constructor init(px,py,pFarbe,pGroesse:Integer); virtual;
        destructor gibFrei;
        procedure zeichne; virtual; abstract;

     end;

implementation

//+---------------------------------------------------------------------
//|         TCorpus: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TCorpus.init(px,py,pFarbe,pGroesse:Integer);
var         zBreite : Integer;
begin
  zx := px;
  zy := py;
  zGroesse := pGroesse;

  case pGroesse of
    1..2  : zBreite:=2;
    3..5  : zBreite:=3;
    6..10 : zBreite:=6;
    else    zBreite:=12;
  end;
  hatBuntStift:=Buntstift.init;
  hatBuntStift.setzeFarbe(pFarbe);
  hatBuntStift.setzeLinienbreite(zBreite);

end;

//-------- gibFrei (public) --------------------------------------------
destructor TCorpus.gibFrei;
begin
  hatBuntstift.gibFrei;
end;

end.
