UNIT mTFluegel;

interface

uses  mSum;

type
   TFluegel = CLASS


     protected
     
        zFluegel       : Integer;
        zGroesse       : Integer;
        zx             : Integer;
        zy             : Integer;
        kenntBuntstift : Buntstift;

     private

     public
        procedure zeichne; virtual;
        constructor init(px,py,pGroesse,pFluegel: Integer; pBuntstift :Buntstift); virtual;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TFluegel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TFluegel.zeichne;
Var   i : Integer;
begin

     for i:= 1 to zFluegel*2 do
        begin
          kenntBuntstift.bewegeBis(zx,zy);
          kenntBuntstift.runter;
          kenntBuntstift.bewegeUm(zGroesse*10);
          kenntBuntstift.hoch;
          kenntBuntstift.dreheUm(360/(2*zFluegel));
         end ;

     kenntBuntstift.dreheUm(360/(2*zFluegel));
 
end;

//-------- init (public) -----------------------------------------------
constructor TFluegel.init(px,py,pGroesse,pFluegel: Integer; pBuntstift :Buntstift);
begin
    zx:=px;
    zy:=py;
    zGroesse:=pGroesse;
    zFluegel:=pFluegel;
    kenntBuntstift:=pBuntstift;
    kenntBuntstift.dreheBis(0.0);

end;

//-------- gibFrei (public) --------------------------------------------
destructor TFluegel.gibFrei;
begin
  // nothing to do
end;

end.
