UNIT mTKnopf;

interface

uses    mSum;

type
   TKnopf = CLASS

      protected
         hatStift  : Buntstift;
         zankerx   : integer;
         zankery   : integer;
         kenntMaus : Maus;
         ztext     : Zeichenkette;
        
     // Methoden
     protected
        procedure zeichne; virtual; abstract;
     public
        constructor init(pankerx,pankery:Integer;pText:Zeichenkette;pMaus:Maus);
        function angeklickt : boolean; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pAnkerx,pAnkery:Integer;pText:Zeichenkette;pMaus:Maus);
begin
  hatStift := Buntstift.init;
  zAnkerx := pAnkerx;
  zAnkery := pAnkery;
  zText   := pText;
  kenntMaus := pMaus;
  zeichne;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  hatStift.gibfrei;
end;

end.
