UNIT mTKreisknopf;

interface

uses    mSum, mTKnopf;

type
   TKreisknopf = CLASS(TKnopf)

      private
        procedure zeichne; override;
      public
        function angeklickt : boolean; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKreisknopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TKreisknopf.zeichne;
begin
  hatStift.hoch;
  hatStift.bewegeBis (zankerx,zankery+10);
  hatStift.runter;
  hatStift.setzeLinienBreite(4);
  hatStift.zeichneKreis (20);
  hatStift.setzeFuellmuster(gefuellt);
  hatStift.setzeFarbe(gelb);
  hatStift.zeichneKreis (17);
  hatStift.setzeFarbe(schwarz);
  hatStift.hoch;
  hatStift.bewegeBis(zankerx-10,zankery);
  hatStift.setzeSchriftGroesse(22);
  hatStift.setzeSchriftstil(1);
  hatStift.schreibeText(zText);
end;

//-------- angeklickt (public) -----------------------------------------
function TKreisknopf.angeklickt : boolean;
begin
  result := kenntMaus.istGedrueckt
  AND (kenntMaus.hposition >= zankerx-20) AND (kenntMaus.hposition <= zankerx+20)
  AND (kenntMaus.vposition >= zankery)    AND (kenntMaus.vposition <= zankery+40);

  if result then hatStift.setzeFarbe(rot) else hatStift.setzeFarbe(weiss);

    hatStift.setzeFuellMuster(durchsichtig);
    hatStift.hoch;
    hatStift.bewegeBis(zAnkerx,zAnkery+10);
    hatStift.zeichneKreis(24);
    hatStift.setzeFarbe(schwarz);

end;


end.
