UNIT mTRechteckknopf;

interface

uses   mSum, mTKnopf;

type
   TRechteckknopf = CLASS(TKnopf)

     private
        zLang : Real;   //Hilfsgre fr Textbreite
     private
        procedure zeichne; override;
     public
        function angeklickt : boolean; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteckknopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TRechteckknopf.zeichne;
begin
  hatStift.hoch;
  hatStift.bewegeBis (zankerx,zankery);
  hatStift.runter;
  hatStift.setzeLinienBreite(2);
  hatStift.setzeSchriftGroesse(22);
  hatStift.setzeSchriftstil(1);
  zLang:=hatStift.Textbreite(zText);
  hatStift.zeichneRechteck(zLang+10,(zLang+10)/2);
  hatStift.setzeFuellmuster(gefuellt);
  hatStift.setzeFarbe(gelb);
  hatStift.bewegeBis (zankerx+2,zankery+2);
  hatStift.zeichneRechteck(zLang+10-4,(zLang+10)/2-4);
  hatStift.setzeFarbe(schwarz);
  hatStift.hoch;
  hatStift.bewegeBis(zankerx+5,zankery+2);
  hatStift.schreibeText(zText);
  hatStift.bewegeBis (zankerx,zankery);
  hatStift.setzeFuellmuster(durchsichtig);
  hatStift.zeichneRechteck(zLang+10,(zLang+10)/2);
end;

//-------- angeklickt (public) -----------------------------------------
function TRechteckknopf.angeklickt : boolean;
begin
  result := kenntMaus.istGedrueckt 
  AND (kenntMaus.hposition >= zankerx)
  AND (kenntMaus.hposition <= zankerx+zLang+10)
  AND (kenntMaus.vposition >= zankery)
  AND (kenntMaus.vposition <= zankery+(zLang+10)/2);

  if result then hatStift.setzeFarbe(rot) else hatStift.setzeFarbe(weiss);

    hatStift.setzeFuellMuster(durchsichtig);
    hatStift.hoch;
    hatStift.bewegeBis(zAnkerx-2,zAnkery-2);
    hatStift.zeichneRechteck(zLang+10+4,(zLang+10)/2+4);
    hatStift.setzeFarbe(schwarz);

end;

end.
