UNIT mTAnwendung;

interface

uses     mSuM, mUhr, mTMuehlen,mTKnopf,mTrechteckknopf,mTKreisknopf;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieMuehle,dieMuehle2,dieMuehle3,dieMuehle4, dieMuehle5, dieMuehle6 : tMuehlen;
        KEnde : TRechteckknopf;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;


        dieUhr : Uhr;

     //Objektbeziehungen:
        // hatMaus : Maus;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  dieMuehle     := TMuehlen.init(250,350,10,600,2);
  dieMuehle2     := TMuehlen.init(350,350,20,500,3);
  dieMuehle3     := TMuehlen.init(450,350,40,400,4);
  dieMuehle4     := TMuehlen.init(550,350,80,300,5);
  dieMuehle5     := TMuehlen.init(650,350,100,200,6);
  dieMuehle6     := TMuehlen.init(750,350,120,100,7);
  KSchneller    := TKreisknopf.init(100,60,'+');
  KLangsamer    := TKreisknopf.init(150,60,'-');
  KEnde         := TRechteckknopf.init(250,60,'end');

end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
  repeat
         if KSchneller.istGetroffen then begin
            dieMuehle.schneller;
            dieMuehle2.schneller;
            dieMuehle3.schneller;
            dieMuehle4.schneller;
            dieMuehle5.schneller;
            dieMuehle6.schneller;
         end
         else if KLangsamer.istGetroffen then begin
            dieMuehle.langsamer;
            dieMuehle2.langsamer;
            dieMuehle3.langsamer;
            dieMuehle4.langsamer;
            dieMuehle5.langsamer;
            dieMuehle6.langsamer;
         end;
         dieMuehle.dreheFluegel;
         dieMuehle2.dreheFluegel;
         dieMuehle3.dreheFluegel;
         dieMuehle4.dreheFluegel;
         dieMuehle5.dreheFluegel;
         dieMuehle6.dreheFluegel;
         dieUhr.warte(10);
    until KEnde.istGetroffen;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei;
end;

end.
