UNIT mTRechteckknopf;

interface

uses  mtKnopf, mSuM;
// Uses-Klausel ggf. anpassen

type
   TRechteckknopf = CLASS(TKnopf)

     // Attribute
     private
        zBreite : zahl;
        zHoehe : zahl;

     // Methoden
     private
        procedure zeichne; override;
     public
        function angeklickt : Boolean; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteckknopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TRechteckknopf.zeichne;
begin
  zBreite := 100; zHoehe := 40;
  hatStift.bewegeBis (zAnkerX, zAnkerY);
  hatStift.zeichneRechteck (zBreite, zHoehe);
  hatStift.bewegeBis (zAnkerX + 10, zAnkerY + 5);
  hatStift.setzeSchriftGroesse (30);
  hatStift.schreibeText (zTitel)
end;

//-------- angeklickt (public) -----------------------------------------
function TRechteckknopf.angeklickt : Boolean;
begin
  result := kenntMaus.istGedrueckt and
            (zAnkerX < kenntMaus.hPosition) and (kenntMaus.hPosition < zAnkerX + zBreite) and
            (zAnkerY < kenntMaus.vPosition) and (kenntMaus.vPosition < zAnkerY + zHoehe)
end;

end.
