UNIT mtSechser;

interface

uses mtMuehle, mSuM; 

type
   tSechser = CLASS(TMuehle)

     // Attribute

     // Methoden
     private
        procedure zeichne; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         tSechser: Methodendefinition
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure tSechser.zeichne;
  procedure rumpf;
  begin
    hatStift.bewegeBis (zX - zBreite / 2, zY - zBreite / 2);
    hatStift.runter;
    hatStift.zeichneRechteck (zBreite, zHoehe);
    hatStift.hoch;
    hatStift.bewegeBis (zx, zy);
    hatStift.zeichneKreis (zBreite/4)
  end;  { rumpf }

  procedure fluegel;
  var i, anzahl_fluegel: integer; w: zahl;
  begin
    anzahl_fluegel := 18;
    hatStift.setzeLinienBreite (10);
    hatStift.hoch;
    hatStift.bewegeBis (zX, zY);
    w := 360/anzahl_fluegel;
    for i := 1 to anzahl_fluegel do
      begin
        hatStift.runter;
        hatStift.bewegeUm (zHoehe/2);
        hatStift.hoch;
        hatStift.bewegeBis (zX, zY);
        hatStift.dreheUm (w);
      end;
    hatStift.dreheUm (w)
  end;  { fluegel }

  begin
    if first then begin first := false; rumpf end;
    fluegel
  end; { tZweier.zeichne }
end.
